package com.izouma.dingdong.web.rider;

import com.izouma.dingdong.utils.SecurityUtils;
import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.rider.Rider;
import com.izouma.dingdong.service.rider.RiderService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.rider.RiderRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/rider")
@AllArgsConstructor
public class RiderController extends BaseController {
    private RiderService riderService;
    private RiderRepo    riderRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Rider save(@RequestBody Rider record) {
        if (record.getId() != null) {
            Rider orig = riderRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return riderRepo.save(orig);
        }
        return riderRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<Rider> all(PageQuery pageQuery) {
        return riderRepo.findAll(toSpecification(pageQuery, Rider.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public Rider get(@PathVariable Long id) {
        return riderRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        riderRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Rider> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }

    @GetMapping("/receiver")
    public void riderReceiveOrder(Long orderId, Boolean pass) {
        riderService.riderReceiveOrder(SecurityUtils.getAuthenticatedUser().getId(), orderId, pass);
    }
}

